#include <amxmodx>
#include <amxmisc>

#include "const.inc"

#include "CvarClassData.inc"
#include "MapsClassData.inc"
#include "MapManagerClassData.inc"

#include "LogClass.inc"
#include "CvarClass.inc"
#include "ConfigClass.inc"
#include "MapsClass.inc"
#include "MapManagerClass.inc"
#include "LoadClass.inc"

#define PLUGIN	"Map Manager"
#define AUTHOR	"AMXX.PL"
#define VERSION	"0.0.1"

public plugin_init(){
	
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	CvarClass.registerCvars();
}

public plugin_cfg(){
	findPluginsAndPause();
	
	ConfigClass.loadConfig();
	
	MapManager.constructor();
	
	switch( ConfigClass.getLoadFrom() ){
		case LOAD_FROM_FILE :{
			new szFileMaps[ 256 ];
			
			formatex( szFileMaps[ get_configsdir( szFileMaps , charsmax( szFileMaps ) ) ] , charsmax( szFileMaps ) - strlen( szFileMaps ) , "/%s/%s" , folderConfig , mapsFile );
			
			LoadClass.loadFromFile( MapManager.getNormalObject() , szFileMaps );
		}
		case LOAD_FROM_FOLDER : {
			new szFolderMaps[ 256 ];
			
			formatex( szFolderMaps[ get_basedir( szFolderMaps , charsmax( szFolderMaps ) ) ] , charsmax( szFolderMaps ) - strlen( szFolderMaps ) , "/maps" );
			
			
			LoadClass.loadFromFolder( MapManager.getNormalObject() , szFolderMaps );
		}
	}
}

public plugin_end(){
	MapManager.destructor();
}

findPluginsAndPause(){
	new pluginsToPause[][] = {
		"mapchooser.amxx",
		"nextmap.amxx",
		"galileo.amxx"
	}
	
	for( new iCurrentMap = 0 ; iCurrentMap < sizeof pluginsToPause ; iCurrentMap++ ){
		if( find_plugin_byfile( pluginsToPause[ iCurrentMap ] , 1 ) != INVALID_PLUGIN_ID ){
			
			pause( "ac" , pluginsToPause[ iCurrentMap ] );
			
			LogClass.logInfo( LOG_CONSOLE_SERVER , "Found %s plugin - Paused" , pluginsToPause[ iCurrentMap ] );
		}
	}
}